# 2. Matrix

## 1) Declaration

Because of functor instance, it's much convenient to choose matrix structure of R.

```haskell
data Matrix a = Matrix { val :: Vector a
                       , row :: Int
                       , col :: Int
                       , byRow :: Bool
                       } deriving (Eq)
```

Thus, to declare Matrix,

```haskell
let a = Matrix { val = vec [1 .. 4], row = 2, col = 2, byRow = True }
-- Matrix [[1,2], [3,4]]
```

But it's too bother thing. So, I prepared syntactic sugar.

```haskell
let a = matrix [[1,2],[3,4]] -- Matrix [[1,2],[3,4]]
```

I recommend latter way.

## 2) Functor, Applicative

Since Matrix has Vector structure, Functor, Applicative instances are same as Vector.

```haskell
(+1) <$> matrix [[1,2],[3,4]] -- Matrix [[2,3],[4,5]]
(+) <$> matrix [[1,2],[3,4]] <*> matrix [[2,3],[4,5]] -- Matrix [[3,5],[7,9]]
```

## 3) Num, Fractional, Floating, Foldable

Just use Vector way.

```haskell
let a = matrix [[1,2],[3,4]]
let b = matrix [[2,3],[4,5]]

a + b
a - b
a * b
a / b
sin a
cos a
tan a

length a
sum a
```